
;rotate LED function using PICF877A (4.433619 Mhz crystel)
;LED bliks in various modes
;compiler using is MPLAB IDE V8.70

#include<P16f877A.inc>
	
COUNT1	equ 0x30	;delay count1 for loop
COUNT2	equ	0x31	;delay count 2 for loop
COUNT3	equ	0x32	;delay count 3 for loop
COMP	equ	0x33	;mode change count

org 0x00
	
START:
	BANKSEL	TRISD
	CLRF	TRISD 		; change portd as o/p
	BANKSEL	PORTD
	MOVLW	B'10000000'
	MOVWF	PORTD		; two bits of port-d make high
	MOVLW	.3			; increase this value to increase
	MOVWF	COUNT3		; delay between blink (rrf or rlf)
	CALL	LOOP
		
ROTATE: 				; to rotate towards right side
	RRF		PORTD,1
	MOVLW	.1			;reload value for loop delay(modify as reqd)
	MOVWF	COUNT3
	BTFSS	STATUS,C	;test carry bit of status register, skip if set
	GOTO	DELAY		;continue rotate until carry bit set
	RRF		PORTD,1		;give an immediate RRF to load carry bit to port-d
DELAY:
	CALL	LOOP

COMP1:					;comparison of register COMP. Instead of 'if'else' function
	BCF		STATUS,Z	;clear zero bit of status register 
	MOVLW	.64			;load value to compare COMP register
	SUBWF	COMP,0		;substract w value from comp register
	BTFSS	STATUS,Z	;test zero bit, bit will set if w is zero. means comp = w
	GOTO	COMP2		;go to next comparison with another value
	MOVLW	B'00000011'	;load new patten value to port-d
	MOVWF	PORTD
	GOTO	ROTATE		;continue in this pattern until next comparison becomes true

COMP2:					;to change mode if comp=128
	MOVLW	.128		
	SUBWF	COMP,0
	BTFSS	STATUS,Z
	GOTO	COMP3
	MOVLW	B'00010101'
	MOVWF	PORTD
	GOTO	ROTATE
COMP3:
	MOVLW	.192
	SUBWF	COMP,0
	BTFSS	STATUS,Z
	GOTO	COMP4
	MOVLW	B'00000001'
	MOVWF	PORTD
	GOTO	ROTATE

COMP4:
	MOVLW	.255
	SUBWF	COMP,0
	BTFSS	STATUS,Z
	GOTO	ROTATE
	MOVLW	B'00010001'
	MOVWF	PORTD
	GOTO	ROTATE
LOOP:						;delay between rrf command
	DECFSZ	COUNT1
	GOTO	LOOP
	DECFSZ	COUNT2
	GOTO	LOOP
	DECFSZ	COUNT3
	GOTO	LOOP
	DECF	COMP
	RETURN
	
	
	END

	;crated on 25th August 2011 by Jyothish.
	;PIC16F877A with 4.433619 Mhz crystel
	;configuration bits not in code hence
	;set configuration bits properly in software before compiling
	;connect eight LEDs in port-d through 1.2k resister.
	;connect cathode of all LEDs to ground	
	;tested and working fine.	